// pages/reservationTemp/edit.js
const app = getApp()
Page({

  /**
   * 页面的初始数据
   */
  data: {
    showModal: false,
    defaultText: '请选择',
    isSubmitting: false,

    reservationType: '2',

    isKeyboard: false, //是否显示车牌输入键盘
    inputOnFocusIndex: '', //当前锁定的车号位置
    licensePlate: '', //用于提交
    inputPlates: '', //用于显示

    appointmentClassifyArray: [
      { label:'充电预约',value:'1' },
      { label:'管桩预约',value:'2' },
      { label:'其他预约',value:'3' },
    ], //预约类型
    appointmentClassifyIndex: '',


  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    //获取详情
    var pages = getCurrentPages();
    var prevPage = pages[pages.length - 2];
    let getInfo = prevPage.data.resData[options.index]

    let getCarNumArr = getInfo.licenseNumber ? getInfo.licenseNumber.split('') : ''
    let inputPlates = {};
    for (let i = 0; i < getCarNumArr.length; i++) {
      inputPlates['index' + i] = getCarNumArr[i]
    }

    this.setData({
      info: getInfo,
      inputPlates: inputPlates,
      isNewEnergy: getCarNumArr.length > 7 ? true : false,
      licensePlate: getInfo.licenseNumber,
      appointmentClassifyIndex: app.util.getDicIndex(this.data.appointmentClassifyArray, getInfo.appointmentClassify, 'value'),
    })

    //this.getSelectData()

  },

  //获取订单下拉列表、车辆轴数下拉列表
  getSelectData:function(){
    //获取订单下拉列表
    // app.request.GET({
    //   url: app.API.orderAllList,
    //   params: {},
    //   page: this,
    //   successFun: true
    // }).then(res => {
    //   this.setData({
    //     orderArray:res.data.data,
    //     orderIndex: app.util.getDicIndex(res.data.data, this.data.info.orderId, 'id'),
    //   })
    // })

    //获取车辆轴数下拉列表
    app.request.GET({
      url: app.API.getCarzheList,
      params: {},
      page: this,
      successFun: true
    }).then(res => {
      this.setData({
        carzheArray:res.data.data,
        carzheIndex: app.util.getDicIndex(res.data.data, this.data.info.overId, 'id'),
      })
    })

  },

  //下拉选择
  bindPickerChange: function (e) { //下拉菜单
    let getIndex = e.target.dataset.pickername + 'Index'
    app.util.getPickerIndex(this, getIndex, e);
  },

  // 单选
  dangerStatusChange: function (e) {
    this.setData({
      [e.currentTarget.dataset.radiotype]: e.detail.value
    })
  },
  //多选
  checkboxChange: function (e) {
    console.log(e.detail)
    this.setData({
      [e.currentTarget.dataset.checkboxtype]: e.detail
    })
  },

  //输入框焦点聚焦时隐藏车牌号输入框
  hideKeybord: function () {
    this.setData({
      isKeyboard: false,
      inputOnFocusIndex: ''
    })
  },
  //获取车牌号
  licensePlate: function (e) {
    this.setData({
      licensePlate: e.detail.carNum
    })
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  bindscrolltolowerFun() {
    
  },


  formSubmit: function ({detail:{value}}) {
    let formData = value;
    let reg = /^1\d{10}$/;
    var xreg = /^[京津沪渝冀豫云辽黑湘皖鲁新苏浙赣鄂桂甘晋蒙陕吉闽贵粤青藏川宁琼使领A-Z]{1}[A-Z]{1}[A-HJ-NP-Z0-9]{4,5}[A-HJ-NP-Z0-9挂学警港澳]{1}$/;
    var creg = /^[京津沪渝冀豫云辽黑湘皖鲁新苏浙赣鄂桂甘晋蒙陕吉闽贵粤青藏川宁琼使领A-Z]{1}[A-Z]{1}[A-HJ-NP-Z0-9]{4}[A-HJ-NP-Z0-9挂学警港澳]{1}$/;
    var warn = ""; //弹框时提示的内容
    if (formData.appointmentClassify == '') {
      warn = "请选择预约分类！";
    } else if (formData.licenseNumber == '') {
      warn = "请选择车牌！";
    } else if (formData.licenseNumber.length < 7) {
      warn = "请选择完整车牌号！";
    } else if (formData.licenseNumber.length == 7 && !creg.test(formData.licenseNumber) && formData.appointmentClassify != '1') {
      warn = "车牌号格式错误！";
    } else if (formData.licenseNumber.length == 8 && !xreg.test(formData.licenseNumber)) {
      warn = "车牌号格式错误！";
    } else if (formData.driverName == '') {
      warn = "请填写司机姓名！";
    } else if (formData.driverMobile == '') {
      warn = "请填写司机电话！";
    } else if (!reg.test(formData.driverMobile)) {
      warn = "司机电话格式错误！";
    }
    if (warn != '') {
      app.util.checkForm(warn);
    } else {
      app.request.POST({
        url: app.API.tempEdit,
        params: value,
        page: this,
        isLoadingTxt: '提交中...',
        isSubmitting: true,
        successFun: true
      }).then(res => {
        wx.showToast({
          title: '修改成功',
          icon: 'success',
          duration: 2000,
          mask:true,
          complete: function () {
            setTimeout(() => {
              wx.navigateBack()
            }, 1500) //延迟时间  
          }
        })
      })

    }
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})